---
title: AudioBufferSourceNode.detune
slug: Web/API/AudioBufferSourceNode/detune
tags:
  - API
  - Audio
  - AudioBufferSourceNode
  - Property
  - Reference
  - Web Audio API
  - detune
---
<div>{{APIRef("Web Audio API")}}</div>

<p class="summary">The <strong><code>detune</code></strong> property of the {{domxref("AudioBufferSourceNode")}} interface is a <a href="/en-US/docs/DOM/AudioParam#k-rate">k-rate</a> {{domxref("AudioParam")}} representing detuning of oscillation in <a href="https://en.wikipedia.org/wiki/Cent_%28music%29">cents</a>.</p>

<p>For example, values of +100 and -100 detune the source up or down by one semitone, while +1200 and -1200 detune it up or down by one octave.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var <em>source</em> = <em>audioCtx</em>.createBufferSource();
<em>source</em>.detune.value = 100; // value in cents</pre>

<div class="note">
<p><strong>Note:</strong> Though the <code>AudioParam</code> returned is read-only, the value it represents is not.</p>
</div>

<h3 id="Value">Value</h3>

<p>A <a href="/en-US/docs/DOM/AudioParam#k-rate">k-rate</a> {{domxref("AudioParam")}} whose value indicates the detuning of oscillation in <a href="https://en.wikipedia.org/wiki/Cent_%28music%29">cents</a>.</p>

<h2 id="Example">Example</h2>

<pre class="brush: js;highlight[18]">const audioCtx = new AudioContext();

const channelCount = 2;
const frameCount = audioCtx.sampleRate * 2.0; // 2 seconds

const myArrayBuffer = audioCtx.createBuffer(channelCount, frameCount, audioCtx.sampleRate);

for (let channel = 0; channel &lt; channelCount; channel++) {
  const nowBuffering = myArrayBuffer.getChannelData(channel);
  for (let i = 0; i &lt; frameCount; i++) {
    nowBuffering[i] = Math.random() * 2 - 1;
  }
}

const source = audioCtx.createBufferSource();
source.buffer = myArrayBuffer;
source.connect(audioCtx.destination);
source.detune.value = 100; // value in cents
source.start();
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Web Audio API', '#dom-audiobuffersourcenode-detune', 'detune')}}</td>
   <td>{{Spec2('Web Audio API')}}</td>
   <td> </td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.AudioBufferSourceNode.detune")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web_Audio_API/Using_Web_Audio_API">Using the Web Audio API</a></li>
</ul>
